#include <limits.h>
#include <stdio.h>

int m, n;
int minCost(int cost[m ][n], int m, int n)
{
    if (n < 0 || m < 0)
        return INT_MAX;
    else if (m == 0 && n == 0)
        return cost[m][n];
    else
        return cost[m][n]+ min(minCost(cost, m - 1, n), minCost(cost, m, n - 1));
}

int min(int x, int y)
{
    if (x < y)
        return x;
    else
        return y;
}

int main()
{
    scanf("%d %d", &m, &n);
    int cost[m][n];
    for(int i = 0; i< m ; i++){
        for(int j = 0; j< n;j++){
            scanf("%lld", &cost[i][j]);
        }
    }
    int q, qx, qy;
    int temp[m][n];
    for(int i = 0; i<m;i++){
        for(int j = 0; j<n;j++){
            temp[i][j] = cost[i][j];
        }
    }
    scanf("%d", &q);
    int niz[q];
    for(int k = 0; k < q; k++){
        scanf("%d %d", &qy, &qx);
        cost[qy-1][qx-1] = 100000000;
        niz[k] = minCost(cost, m-1, n-1);
        for(int i = 0; i<m;i++){
            for(int j = 0; j<n;j++){
                cost[i][j] = temp[i][j];
            }
        }
    }
    for(int i = 0;i < q;i++){
        printf("%d \n", niz[i]);
    }
    return 0;
}